# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ReverseIpv4Args', 'ReverseIpv4']

@pulumi.input_type
class ReverseIpv4Args:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 ip: pulumi.Input[str],
                 reverse: pulumi.Input[str]):
        """
        The set of arguments for constructing a ReverseIpv4 resource.
        :param pulumi.Input[str] instance_id: The ID of the instance you want to set an IPv4
               reverse DNS record for.
        :param pulumi.Input[str] ip: The IPv4 address used in the reverse DNS record.
        :param pulumi.Input[str] reverse: The hostname used in the IPv4 reverse DNS record.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "ip", ip)
        pulumi.set(__self__, "reverse", reverse)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        The ID of the instance you want to set an IPv4
        reverse DNS record for.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def ip(self) -> pulumi.Input[str]:
        """
        The IPv4 address used in the reverse DNS record.
        """
        return pulumi.get(self, "ip")

    @ip.setter
    def ip(self, value: pulumi.Input[str]):
        pulumi.set(self, "ip", value)

    @property
    @pulumi.getter
    def reverse(self) -> pulumi.Input[str]:
        """
        The hostname used in the IPv4 reverse DNS record.
        """
        return pulumi.get(self, "reverse")

    @reverse.setter
    def reverse(self, value: pulumi.Input[str]):
        pulumi.set(self, "reverse", value)


@pulumi.input_type
class _ReverseIpv4State:
    def __init__(__self__, *,
                 gateway: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 netmask: Optional[pulumi.Input[str]] = None,
                 reverse: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ReverseIpv4 resources.
        :param pulumi.Input[str] gateway: The gateway IP address.
        :param pulumi.Input[str] instance_id: The ID of the instance you want to set an IPv4
               reverse DNS record for.
        :param pulumi.Input[str] ip: The IPv4 address used in the reverse DNS record.
        :param pulumi.Input[str] netmask: The IPv4 netmask in dot-decimal notation.
        :param pulumi.Input[str] reverse: The hostname used in the IPv4 reverse DNS record.
        """
        if gateway is not None:
            pulumi.set(__self__, "gateway", gateway)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if ip is not None:
            pulumi.set(__self__, "ip", ip)
        if netmask is not None:
            pulumi.set(__self__, "netmask", netmask)
        if reverse is not None:
            pulumi.set(__self__, "reverse", reverse)

    @property
    @pulumi.getter
    def gateway(self) -> Optional[pulumi.Input[str]]:
        """
        The gateway IP address.
        """
        return pulumi.get(self, "gateway")

    @gateway.setter
    def gateway(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gateway", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the instance you want to set an IPv4
        reverse DNS record for.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def ip(self) -> Optional[pulumi.Input[str]]:
        """
        The IPv4 address used in the reverse DNS record.
        """
        return pulumi.get(self, "ip")

    @ip.setter
    def ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip", value)

    @property
    @pulumi.getter
    def netmask(self) -> Optional[pulumi.Input[str]]:
        """
        The IPv4 netmask in dot-decimal notation.
        """
        return pulumi.get(self, "netmask")

    @netmask.setter
    def netmask(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "netmask", value)

    @property
    @pulumi.getter
    def reverse(self) -> Optional[pulumi.Input[str]]:
        """
        The hostname used in the IPv4 reverse DNS record.
        """
        return pulumi.get(self, "reverse")

    @reverse.setter
    def reverse(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "reverse", value)


class ReverseIpv4(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 reverse: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a Vultr Reverse IPv4 resource. This can be used to create, read, and
        modify reverse DNS records for IPv4 addresses. Upon success, DNS
        changes may take 6-12 hours to become active.

        ## Example Usage

        Create a new reverse DNS record for an IPv4 address:

        ```python
        import pulumi
        import ediri_vultr as vultr

        my_instance = vultr.Instance("myInstance",
            enable_ipv6=True,
            os_id=167,
            plan="vc2-1c-1gb",
            region="ewr")
        my_reverse_ipv4 = vultr.ReverseIpv4("myReverseIpv4",
            instance_id=my_instance.id,
            ip=my_instance.main_ip,
            reverse="host.example.com")
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: The ID of the instance you want to set an IPv4
               reverse DNS record for.
        :param pulumi.Input[str] ip: The IPv4 address used in the reverse DNS record.
        :param pulumi.Input[str] reverse: The hostname used in the IPv4 reverse DNS record.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ReverseIpv4Args,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a Vultr Reverse IPv4 resource. This can be used to create, read, and
        modify reverse DNS records for IPv4 addresses. Upon success, DNS
        changes may take 6-12 hours to become active.

        ## Example Usage

        Create a new reverse DNS record for an IPv4 address:

        ```python
        import pulumi
        import ediri_vultr as vultr

        my_instance = vultr.Instance("myInstance",
            enable_ipv6=True,
            os_id=167,
            plan="vc2-1c-1gb",
            region="ewr")
        my_reverse_ipv4 = vultr.ReverseIpv4("myReverseIpv4",
            instance_id=my_instance.id,
            ip=my_instance.main_ip,
            reverse="host.example.com")
        ```

        :param str resource_name: The name of the resource.
        :param ReverseIpv4Args args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ReverseIpv4Args, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 reverse: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ReverseIpv4Args.__new__(ReverseIpv4Args)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if ip is None and not opts.urn:
                raise TypeError("Missing required property 'ip'")
            __props__.__dict__["ip"] = ip
            if reverse is None and not opts.urn:
                raise TypeError("Missing required property 'reverse'")
            __props__.__dict__["reverse"] = reverse
            __props__.__dict__["gateway"] = None
            __props__.__dict__["netmask"] = None
        super(ReverseIpv4, __self__).__init__(
            'vultr:index/reverseIpv4:ReverseIpv4',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            gateway: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            ip: Optional[pulumi.Input[str]] = None,
            netmask: Optional[pulumi.Input[str]] = None,
            reverse: Optional[pulumi.Input[str]] = None) -> 'ReverseIpv4':
        """
        Get an existing ReverseIpv4 resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] gateway: The gateway IP address.
        :param pulumi.Input[str] instance_id: The ID of the instance you want to set an IPv4
               reverse DNS record for.
        :param pulumi.Input[str] ip: The IPv4 address used in the reverse DNS record.
        :param pulumi.Input[str] netmask: The IPv4 netmask in dot-decimal notation.
        :param pulumi.Input[str] reverse: The hostname used in the IPv4 reverse DNS record.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ReverseIpv4State.__new__(_ReverseIpv4State)

        __props__.__dict__["gateway"] = gateway
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["ip"] = ip
        __props__.__dict__["netmask"] = netmask
        __props__.__dict__["reverse"] = reverse
        return ReverseIpv4(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def gateway(self) -> pulumi.Output[str]:
        """
        The gateway IP address.
        """
        return pulumi.get(self, "gateway")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        The ID of the instance you want to set an IPv4
        reverse DNS record for.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def ip(self) -> pulumi.Output[str]:
        """
        The IPv4 address used in the reverse DNS record.
        """
        return pulumi.get(self, "ip")

    @property
    @pulumi.getter
    def netmask(self) -> pulumi.Output[str]:
        """
        The IPv4 netmask in dot-decimal notation.
        """
        return pulumi.get(self, "netmask")

    @property
    @pulumi.getter
    def reverse(self) -> pulumi.Output[str]:
        """
        The hostname used in the IPv4 reverse DNS record.
        """
        return pulumi.get(self, "reverse")

